//------------------------------------------------------------------------------
//	$Id: decay-compute-ks.cc,v 1.1 2024/03/13 20:21:10 wolf Exp $
//------------------------------------------------------------------------------

#include <stdint.h>

#include "decay-compute-ks.h"
#include "u32p32exp2m1.h"

int32_t
compute_ks( uint32_t f_hz, uint32_t th_us ){

	const uint64_t nominator = (1000ul * 1000ul) << 32;
	const uint64_t cs64 = nominator / f_hz / th_us;
	const uint32_t cs   = cs64 <= UINT32_MAX ? (uint32_t) cs64 : UINT32_MAX;
	const uint32_t ps   = u32p32exp2m1( cs );

	const uint64_t nom  = 1ul << 63;
	const uint64_t den  = ps + ( 1ul << 32 );

	const uint64_t ks64 = nom / den;
	const  int32_t ks   = ks64 <=  INT32_MAX ? ( int32_t) ks64 :  INT32_MAX;

	return ks;
}

//------------------------------------------------------------------------------
//	$Id: decay-compute-ks.cc,v 1.1 2024/03/13 20:21:10 wolf Exp $
//------------------------------------------------------------------------------
