//------------------------------------------------------------------------------
//	$Id: decay-filter.cc,v 1.1 2024/03/13 20:21:10 wolf Exp $
//------------------------------------------------------------------------------

#include <stdint.h>

#include "decay-filter.h"

static inline int64_t
mul32_64( int32_t a, int32_t b ){

	return (int64_t) a * b;
}

void
decay_filter( int32_t in, int32_t ks, int32_t *outp ){

	const register int64_t sum =
		mul32_64( *outp,             ks ) +
		mul32_64(  in  , INT32_MIN - ks );

	if( sum >= 0 ){

		*outp = +(int32_t)( (+sum) >> 31 );
	} else {
		*outp = -(int32_t)( (-sum) >> 31 );
	}
}

//------------------------------------------------------------------------------
//	$Id: decay-filter.cc,v 1.1 2024/03/13 20:21:10 wolf Exp $
//------------------------------------------------------------------------------
